var DLNA_timeoutVar = undefined;
var DLNA_timeoutVar2 = undefined;
var DLNA_browserIE = false
var DLNA_parseXml = undefined;

var DLNA_prevControls = undefined;
var DLNA_prevOnlineState = undefined;
var DLNA_prevCurrentAlbumArtUrl = undefined;
var DLNA_prevTitle = undefined;
var DLNA_prevAlbum = undefined;
var DLNA_prevArtist = undefined;
var DLNA_prevDuration = undefined;
var DLNA_prevPlaying = undefined;
var DLNA_prevActions = undefined;
var DLNA_prevMute = undefined;
var DLNA_prevVolume = undefined;

var DLNA_prevModelName = undefined;
var DLNA_prevUrl = undefined;
var DLNA_prevOnlineState2 = undefined;
var DLNA_prevProxy = undefined;
var DLNA_prevResultDiscovery = undefined;
var DLNA_prevResultDiscovery2 = undefined;
var DLNA_prevResultBrowse = undefined;
var DLNA_prevSinkProtocols = undefined;
var DLNA_prevResultPlayback = undefined;

var DLNA_mediaObjects = new Array();
var DLNA_selectedMedia = undefined;
var DLNA_loading = false;
var DLNA_lastSelectedDMS = '';
var DLNA_lastPlayedMediaObject = '';
var DLNA_lastUsedProtocol = '';

var DLNA_DMC_SID = 'urn:dlna-org:serviceId:DLNAMediaController1';
var AVTRANSPORT_SID = 'urn:upnp-org:serviceId:AVTransport';
var RENDERING_CONTROL_SID = 'urn:upnp-org:serviceId:RenderingControl';
var MEDIA_NAVIGATION_SID = 'urn:micasaverde-com:serviceId:MediaNavigation1';
var VOLUME_SID = 'urn:micasaverde-com:serviceId:Volume1';
var UPNP_CONNECTION_MANAGER_SID = 'urn:upnp-org:serviceId:ConnectionManager';

function DLNA_showPlayer(device)
{
	if (typeof DLNA_timeoutVar != 'undefined') {
		clearTimeout(DLNA_timeoutVar);
	}

	DLNA_detectBrowser();

	DLNA_initXMLParser();

	var html = '';

	html += '<table>';
	html += '<tr>';
	html += '<td rowspan=4><img id="albumArt" width="100" height="100"/></td>';
	html += '<td id="artistLabel">Artist:</td>';
	html += '<td id="artist"></td>';
	html += '</tr>';
	html += '<tr>';
	html += '<td id="albumLabel">Album:</td>';
	html += '<td id="album"></td>';
	html += '</tr>';
	html += '<tr>';
	html += '<td id="titleLabel">Track title:</td>';
	html += '<td id="title"></td>';
	html += '</tr>';
	html += '<tr>';
	html += '<td id="durationLabel"></td>';
	html += '<td id="duration"></td>';
	html += '</tr>';
	html += '</table>';
	html += '<DIV>'
	html += '<table>';
	html += '<tr>';
	html += '<td>';
	html += '<button id="prevTrack" type="button" style="background-color:lightgrey; height: 25px; width: 50px" onclick="DLNA_prevTrack('+device+');">Prev</button>';
	html += '</td>';
	html += '<td>';
	html += '<button id="play" type="button" style="background-color:lightgrey; height: 25px; width: 50px" onclick="DLNA_play('+device+');">Play</button>';
	html += '</td>';
	html += '<td>';
	html += '<button id="pause" type="button" style="background-color:lightgrey; height: 25px; width: 50px" onclick="DLNA_pause('+device+');">Pause</button>';
	html += '</td>';
	html += '<td>';
	html += '<button id="stop" type="button" style="background-color:lightgrey; height: 25px; width: 50px" onclick="DLNA_stop('+device+');">Stop</button>';
	html += '</td>';
	html += '<td>';
	html += '<button id="nextTrack" type="button" style="background-color:lightgrey; height: 25px; width: 50px" onclick="DLNA_nextTrack('+device+');">Next</button>';
	html += '</td>';
	html += '<td>';
	html += '<button id="mute" type="button" style="background-color:lightgrey; height: 25px; width: 50px" onclick="DLNA_mute('+device+');">Mute</button>';
	html += '</td>';
	html += '<td>';
	html += '<input id="controls" type="checkbox" checked value="1">Buttons state controlled by Renderer';
	html += '</td>';
	html += '</tr>';
	html += '</table>';
	html += '</DIV>'
	html += '<DIV>'
	html += '<table>';
	html += '<tr>';
	html += '<td>URI:</td>';
	html += '<td>';
	html += '<input id="uri" type="text" style="margin-right: 15px; width: 227px"/>';
	html += 'Duration:';
	html += '<input id="duration1" type="text" value="" style="margin-left: 5px; margin-right: 16px; width: 35px"/>';
	html += 'Volume:';
	html += '<input id="volume1" type="text" value="" style="margin-left: 5px; width: 20px"/>';
	html += '</td>';
	html += '</tr>';
	html += '<tr>';
	html += '<td>Protocol:</td>';
	html += '<td>';
	html += '<select id="sinkProtocols"/>';
	html += '<button id="playUri" type="button" style="margin-left: 10px; background-color:lightgrey; height: 25px; width: 50px" onclick="DLNA_playUri('+device+');">Play</button>';
	html += '</td>';
	html += '</tr>';

	var languages = [	[ "en", "English" ],
						[ "fr", "French" ],
						[ "it", "Italian" ],
						[ "es", "Spanish" ],
						[ "ru", 'Russian' ] ];
	var defaultLanguage = get_device_state(device, DLNA_DMC_SID, "DefaultLanguageTTS", 1);
	if (defaultLanguage == undefined) {
		defaultLanguage = 'en';
	}

	html += '<tr>';
	html += '<td>Text To Speech:</td>';
	html += '<td>';
	html += '<input id="text" type="text" style="margin-right: 10px; width: 227px"/>';
	html += '<select id="language1" style="margin-right: 5px;" onChange="DLNA_selectLang();">';
	for (i=0; i<languages.length; i++) {
		html += '<option';
		if (languages[i][0] == defaultLanguage) {
			html += ' selected';
		}
		html += ' value="' + languages[i][0] + '">' + languages[i][1] + '</option>';
	}
	html += '</select>';
	html += '<input id="language" type="text" value="' + defaultLanguage + '" style="margin-right: 10px; width: 20px"/>';
	html += 'Volume:';
	html += '<input id="volume" type="text" value="" style="margin-left: 5px; width: 20px"/>';
	html += '<button id="say" type="button" style="margin-left: 10px; background-color:lightgrey; height: 25px; width: 50px" onclick="DLNA_say('+device+');">Say</button>';
	html += '</td>';
	html += '</tr>';
	html += '<td>Media:</td>';
	html += '<td><select id="media" onChange="DLNA_selectMedia();"/></td>';
	html += '</tr>';
	html += '<tr>';
	html += '<td>Protocol:</td>';
	html += '<td><select id="protocols"/></td>';
	html += '</tr>';
	html += '</table>';
	html += '<table>';
	html += '<tr>';
	html += '<td>';
	html += '<button id="discover" type="button" style="background-color:lightgrey; height: 25px; width: 150px" onclick="DLNA_startDMSDiscovery('+device+');">Discover Servers</button>';
	html += '</td>';
	html += '<td>';
	html += '<button id="browse" type="button" style="background-color:lightgrey; height: 25px; width: 75px" onclick="DLNA_browseMedia('+device+');">Browse</button>';
	html += '</td>';
	html += '<td>';
	html += '<button id="back" type="button" style="background-color:lightgrey; height: 25px; width: 75px" onclick="DLNA_browseBack('+device+');">Back</button>';
	html += '</td>';
	html += '<td>';
	html += '<button id="top" type="button" style="background-color:lightgrey; height: 25px; width: 75px" onclick="DLNA_browseTop('+device+');">Top</button>';
	html += '</td>';
	html += '<td><label id="status"/></td>';
	html += '</tr>';
	html += '</table>';
	html += '</DIV>'
	
	//html += '<p id="debug">';

	set_panel_html(html);

	DLNA_prevControls = undefined;
	DLNA_prevOnlineState = undefined;
	DLNA_prevCurrentAlbumArtUrl = undefined;
	DLNA_prevTitle = undefined;
	DLNA_prevAlbum = undefined;
	DLNA_prevArtist = undefined;
	DLNA_prevDuration = undefined;
	DLNA_prevPlaying = undefined;
	DLNA_prevActions = undefined;
	DLNA_prevMute = undefined;
	DLNA_prevVolume = undefined;
	DLNA_prevResultDiscovery = undefined;
	DLNA_prevResultBrowse = undefined;
	DLNA_prevSinkProtocols = undefined;
	DLNA_prevResultPlayback = undefined;

	DLNA_refreshPlayer(device);
}

function DLNA_showSettings(device)
{
	if (typeof DLNA_timeoutVar2 != 'undefined') {
		clearTimeout(DLNA_timeoutVar2);
	}

	DLNA_detectBrowser();

	DLNA_initXMLParser();

	var html = '';

	html += '<table cellspacing="10">';
	html += '<tr><td colspan=2><u>Current settings</u></td></tr>';
	html += '<tr>';
	html += '<td>DMR model:</td>';
	html += '<td id="model"></td>';
	html += '</tr>';
	html += '<tr>';
	html += '<td>Description URL:</td>';
	html += '<td id="url"></td>';
	html += '</tr>';
	html += '<tr>';
	html += '<td>State:</td>';
	html += '<td>';
	html += '<label id="state"/>';
	html += '<button id="checkState" type="button" style="margin-left: 10px; background-color:lightgrey; height: 25px; width: 75px" onclick="DLNA_checkState('+device+');">Check</button>';
	html += '</td>';
	html += '</tr>';
	html += '<tr>';
	html += '<td>UPnP Event proxy:</td>';
	html += '<td id="proxy"></td>';
	html += '</tr>';
	html += '<tr><td colspan=2><u>New settings</u></td></tr>';
	html += '<tr><td colspan=2>Push "discover" button, then select your Media Renderer in the list and finally push "Select" button.';
	html += '<BR>If UPnP discovery is not working, fill in your DMR description URL and finally push "Select" button.</td></tr>';
	html += '<tr>';
	html += '<td>';
	html += '<button id="DMRdiscover" type="button" style="background-color:lightgrey; height: 25px; width: 90px" onclick="DLNA_startDMRDiscovery('+device+');">Discover</button>';
	html += '</td>';
	html += '<td>';
	html += '<select id="DMRdiscovery"/>';
	html += '<button id="selectDMRDiscovery" type="button" style="margin-left: 10px; background-color:lightgrey; height: 25px; width: 75px" onclick="DLNA_selectDMRDiscovery('+device+');">Select</button>';
	html += '</td>';
	html += '</tr>';
	html += '<tr>';
	html += '<td>New URL:</td>';
	html += '<td>';
	html += '<input id="newURL" type="text" style="width: 380px"/>';
	html += '<button id="selectURL" type="button" style="margin-left: 10px; background-color:lightgrey; height: 25px; width: 50px" onclick="DLNA_selectURL('+device+');">Select</button>';
	html += '</td>';
	html += '</tr>';
	html += '</table>';

	//html += '<p id="debug">';

	set_panel_html(html);

	DLNA_prevModelName = undefined;
	DLNA_prevUrl = undefined;
	DLNA_prevOnlineState2 = undefined;
	DLNA_prevProxy = undefined;
	DLNA_prevResultDiscovery2 = undefined;

	DLNA_refreshDiscovery(device);
}

function DLNA_showHelp(device)
{
	var html = '<table cellspacing="10">';
	html += '<tr>';
	html += '<td>DMS description URL:</td>';
	html += '<td>' + DLNA_lastSelectedDMS + '</td>';
	html += '</tr>';
	html += '<tr>';
	html += '<td>Last server media played:</td>';
	html += '<td>' + DLNA_lastPlayedMediaObject + '</td>';
	html += '</tr>';
	html += '<tr>';
	html += '<td>Selected protocol:</td>';
	html += '<td>' + DLNA_lastUsedProtocol + '</td>';
	html += '</tr>';
	html += '</table>';

	var variables = [	[ AVTRANSPORT_SID, "AVTransportURI" ],
						[ AVTRANSPORT_SID, "AVTransportURIMetaData" ],
						[ AVTRANSPORT_SID, "CurrentTrackURI" ],
						[ AVTRANSPORT_SID, "CurrentTrackMetaData" ],
						[ UPNP_CONNECTION_MANAGER_SID, 'SinkProtocolInfo' ] ];
	html += '<table border="1">';
	html += '<tr align="center" bgcolor="LightBlue">';
	html += '<th>Variable</td>';
	html += '<th>Value</td>';
	html += '</tr>';
	for (i=0; i<variables.length; i++) {
		var value = get_device_state(device, variables[i][0], variables[i][1], 1);
		if (value == undefined) {
			value = '';
		}
		html += '<tr>';
		html += '<td>' + variables[i][1] + '</td>';
		html += '<td>' + DLNA_escapeHtmlSpecialChars(value) + '</td>';
		html += '</tr>';
	}
	html += '</table>';

	html += '<BR>';

	set_panel_html(html);
}

function DLNA_detectBrowser()
{
	var place = navigator.userAgent.toLowerCase().indexOf('msie');
	if (place == -1) {
		DLNA_browserIE = false;
	}
	else {
		DLNA_browserIE = true;
	}
}

function DLNA_initXMLParser()
{
	if (typeof DLNA_parseXml == 'undefined') {
		if (typeof window.DOMParser != "undefined") {
			DLNA_parseXml = function(xmlStr) {
				return ( new window.DOMParser() ).parseFromString(xmlStr, "text/xml");
			};
		}
		else if (typeof window.ActiveXObject != "undefined" && new window.ActiveXObject("Microsoft.XMLDOM")) {
			DLNA_parseXml = function(xmlStr) {
				var xmlDoc = new window.ActiveXObject("Microsoft.XMLDOM");
				xmlDoc.async = "false";
				xmlDoc.loadXML(xmlStr);
				return xmlDoc;
			};
		}
		else {
			DLNA_parseXml = function(xmlStr) {
				return undefined;
			};
		}
	}
}

function DLNA_extractXmlTag(parent, tag)
{
	var value = undefined;
	for (j=0; j<parent.childNodes.length; j++) {
		if (parent.childNodes[j].tagName == tag) {
			value = parent.childNodes[j].textContent;
			break;
		}
	}
	return value;
}

function DLNA_extractXmlAttribute(node, attribute)
{
	var value = node.getAttribute(attribute);
	return value;
}

function DLNA_escapeHtmlSpecialChars(unsafe)
{
	return unsafe
			.replace(/&/g, "&amp;")
			.replace(/</g, "&lt;")
			.replace(/>/g, "&gt;")
			.replace(/"/g, "&quot;");
}

function DLNA_refreshPlayer(device)
{
	var controls = $('controls').checked;
	var onlineState = get_device_state(device, DLNA_DMC_SID, "Online", 1);
	if (onlineState == undefined) {
		onlineState = '1';
	}
	var currentAlbumArtUrl = get_device_state(device, AVTRANSPORT_SID, "CurrentAlbumArt2", 1);
	if (currentAlbumArtUrl == undefined) {
		currentAlbumArtUrl = '';
	}
	var title = get_device_state(device, AVTRANSPORT_SID, "CurrentTitle", 1);
	if (title == undefined) {
		title = '';
	}
	var album = get_device_state(device, AVTRANSPORT_SID, "CurrentAlbum", 1);
	if (album == undefined) {
		album = '';
	}
	var artist = get_device_state(device, AVTRANSPORT_SID, "CurrentArtist", 1);
	if (artist == undefined) {
		artist = '';
	}
	var duration = get_device_state(device, AVTRANSPORT_SID, "CurrentTrackDuration", 1);
	if (duration == undefined || duration == 'NOT_IMPLEMENTED'
			|| duration == '0:00:00' || duration == '00:00:00') {
		duration = '';
	}
	var playing = get_device_state(device, AVTRANSPORT_SID, "TransportState", 1);
	if (playing == undefined) {
		playing = '';
	}
	var actions = get_device_state(device, AVTRANSPORT_SID, "CurrentTransportActions", 1);
	if (actions == undefined) {
		actions = '';
	}
	actions = actions.toLowerCase();
	var mute = get_device_state(device, RENDERING_CONTROL_SID, "Mute", 1);
	if (mute == undefined || mute == "") {
		mute = '0';
	}
	var volume = get_device_state(device, RENDERING_CONTROL_SID, "Volume", 1);
	if (volume == undefined || volume == "") {
		volume = 0;
	}
	var resultDiscovery = get_device_state(device, DLNA_DMC_SID, "DMSDiscoveryResult", 1);
	if (resultDiscovery == undefined) {
		resultDiscovery = '';
	}
	var resultBrowse = get_device_state(device, DLNA_DMC_SID, "BrowseResult", 1);
	if (resultBrowse == undefined) {
		resultBrowse = '';
	}
	var sinkProtocols = get_device_state(device, UPNP_CONNECTION_MANAGER_SID, "SinkProtocolInfo", 1);
	if (sinkProtocols == undefined) {
		sinkProtocols = '';
	}
	var resultPlayback = get_device_state(device, DLNA_DMC_SID, "PlaybackResult", 1);
	if (resultPlayback == undefined) {
		resultPlayback = '';
	}

	if (controls != DLNA_prevControls
		|| onlineState != DLNA_prevOnlineState
		|| currentAlbumArtUrl != DLNA_prevCurrentAlbumArtUrl
		|| title != DLNA_prevTitle
		|| album != DLNA_prevAlbum
		|| artist != DLNA_prevArtist
		|| duration != DLNA_prevDuration
		|| playing != DLNA_prevPlaying
		|| actions != DLNA_prevActions
		|| mute != DLNA_prevMute
		|| volume != DLNA_prevVolume
		|| resultDiscovery != DLNA_prevResultDiscovery
		|| resultBrowse != DLNA_prevResultBrowse
		|| sinkProtocols != DLNA_prevSinkProtocols
		|| resultPlayback != DLNA_prevResultPlayback) {

		$('albumArt').src = currentAlbumArtUrl;

		var label;

		if (title != '') {
			label = 'Title:';
		}
		else {
			label = '';
		}
		$('titleLabel').innerHTML = label;
		$('title').innerHTML = title;

		if (album != '') {
			label = 'Album:';
		}
		else {
			label = '';
		}
		$('albumLabel').innerHTML = label;
		$('album').innerHTML = album;

		if (artist != '') {
			label = 'Artist:';
		}
		else {
			label = '';
		}
		$('artistLabel').innerHTML = label;
		$('artist').innerHTML = artist;

		if (duration != '') {
			label = 'Duration:';
		}
		else {
			label = '';
		}
		$('durationLabel').innerHTML = label;
		$('duration').innerHTML = duration;

		if (onlineState != '1') {
			$('titleLabel').innerHTML = 'Offline';
			$('title').innerHTML = '';
			$('play').style.backgroundColor = 'lightgrey';
			$('pause').style.backgroundColor = 'lightgrey';
			$('stop').style.backgroundColor = 'lightgrey';
			$('play').disabled = true;
			$('pause').disabled = true;
			$('stop').disabled = true;
			$('prevTrack').disabled = true;
			$('nextTrack').disabled = true;
			$('controls').disabled = true;
		}
		else {
			$('controls').disabled = false;
			if (playing == 'PLAYING' || playing == 'TRANSITIONING') {
				$('play').style.backgroundColor = 'darkgray';
				$('pause').style.backgroundColor = 'lightgrey';
				$('stop').style.backgroundColor = 'lightgrey';
			}
			else if (playing == 'PAUSED_PLAYBACK') {
				$('play').style.backgroundColor = 'lightgrey';
				$('pause').style.backgroundColor = 'darkgray';
				$('stop').style.backgroundColor = 'lightgrey';
			}
			else if (playing == 'STOPPED') {
				$('play').style.backgroundColor = 'lightgrey';
				$('pause').style.backgroundColor = 'lightgrey';
				$('stop').style.backgroundColor = 'darkgray';
			}
			else {
				$('play').style.backgroundColor = 'lightgrey';
				$('pause').style.backgroundColor = 'lightgrey';
				$('stop').style.backgroundColor = 'lightgrey';
			}

			if (controls == false) {
				$('play').disabled = false;
				$('pause').disabled = false;
				$('stop').disabled = false;
				$('prevTrack').disabled = false;
				$('nextTrack').disabled = false;
			}
			else {
				if (actions.indexOf('play', 0) >= 0) {
					$('play').disabled = false;
				}
				else {
					$('play').disabled = true;
				}
				if (actions.indexOf('pause', 0) >= 0) {
					$('pause').disabled = false;
				}
				else {
					$('pause').disabled = true;
				}
				if (actions.indexOf('stop', 0) >= 0) {
					$('stop').disabled = false;
				}
				else {
					$('stop').disabled = true;
				}
				if (actions.indexOf('previous', 0) < 0) {
					$('prevTrack').disabled = true;
				}
				else {
					$('prevTrack').disabled = false;
				}
				if (actions.indexOf('next', 0) < 0) {
					$('nextTrack').disabled = true;
				}
				else {
					$('nextTrack').disabled = false;
				}
			}
		}

		if (mute == '1' || mute == 'true' || mute == 'yes') {
			$('mute').style.backgroundColor = 'darkgray';
		}
		else {
			$('mute').style.backgroundColor = 'lightgrey';
		}

		if (onlineState == '1') {
			$('mute').disabled = false;
			$('playUri').disabled = false;
			$('say').disabled = false;
		}
		else {
			$('mute').disabled = true;
			$('playUri').disabled = true;
			$('say').disabled = true;
		}

		if (sinkProtocols != DLNA_prevSinkProtocols) {
			var html = '';
			var values;
			var protocol;
			html = '<option selected value="">None</option>';
			values = sinkProtocols.split(',');
			for (i=0; i<values.length; i++) {
				if (values[i].length > 50) {
					protocol = values[i].substr(0, 50) + '...';
				}
				else {
					protocol = values[i];
				}
				html += '<option value="' + values[i] + '">' + protocol + '</option>';
			}
			$('sinkProtocols').innerHTML = html;
			if (DLNA_browserIE) {
				$('sinkProtocols').outerHTML=$('sinkProtocols').outerHTML.replace($('sinkProtocols').innerHTML+'</select>',html+'</select>');
			}
		}

		if (resultDiscovery != DLNA_prevResultDiscovery
			|| resultBrowse != DLNA_prevResultBrowse) {

			if (resultBrowse == '') {
				DLNA_selectedMedia = undefined;
				DLNA_mediaObjects = new Array();
			}

			if (DLNA_mediaObjects.length == 0) {
				if (resultDiscovery == 'scanning') {
					DLNA_loading = true;
					$('media').innerHTML = '';
					$('discover').disabled = true;
					$('browse').disabled = true;
					$('back').disabled = true;
					$('top').disabled = true;
				}
				else if (resultDiscovery == '') {
					DLNA_loading = false;
					$('media').innerHTML = '';
					$('discover').disabled = false;
					$('browse').disabled = true;
					$('back').disabled = true;
					$('top').disabled = true;
				}
				else {
					$('discover').disabled = false;
					$('browse').disabled = false;
					$('back').disabled = false;
					$('top').disabled = false;

					var html = '';
					var xml = DLNA_parseXml(resultDiscovery);
					if (typeof xml != 'undefined') {
						var items = xml.getElementsByTagName("device");
						for (i=0; i<items.length; i++) {
							url = DLNA_extractXmlTag(items[i], 'descriptionURL');
							if (url == undefined) {
								url = '';
							}
							modelName = DLNA_extractXmlTag(items[i], 'friendlyName');
							if (modelName == undefined) {
								modelName = '';
							}
							// var ip = DLNA_extractXmlTag(items[i], 'ip');
							// if (ip == undefined) {
								// ip = '';
							// }
							url = 'server:' + url;
							html += '<option ';
							if (url == DLNA_selectedMedia) {
								html += 'selected ';
							}
							// html += 'value="' + url + '">' + modelName + ' (IP ' + ip + ')</option>';
							html += 'value="' + url + '">' + modelName + '</option>';
						}
					}
					$('media').innerHTML = html;
					if (DLNA_browserIE) {
						$('media').outerHTML=$('media').outerHTML.replace($('media').innerHTML+'</select>',html+'</select>');
					}
					DLNA_loading = false;
				}
			}
			else if (resultBrowse == 'loading') {
				DLNA_disableDMSCmds();
			}
			else {
				$('discover').disabled = false;
				$('browse').disabled = false;
				$('back').disabled = false;
				$('top').disabled = false;

				var html = '';
				var xml = DLNA_parseXml(resultBrowse);
				if (typeof xml != 'undefined') {
					var title2;
					var id;
					var containers = xml.getElementsByTagName("container");
					for (i=0; i<containers.length; i++) {
						title2 = DLNA_extractXmlTag(containers[i], 'dc:title');
						if (title2 == undefined) {
							title2 = '';
						}
						if (title2.length > 60) {
							title2 = title2.substr(0, 60) + '...';
						}
						id = DLNA_extractXmlAttribute(containers[i], 'id');
						if (id == undefined) {
							id = '';
						}
						id = 'container:' + id;
						html += '<option ';
						if (id == DLNA_selectedMedia) {
							html += 'selected ';
						}
						html += 'value="' + id + '">+ ' + title2 + '</option>';
					}
					var items = xml.getElementsByTagName("item");
					for (i=0; i<items.length; i++) {
						title2 = DLNA_extractXmlTag(items[i], 'dc:title');
						if (title2 == undefined) {
							title2 = '';
						}
						if (title2.length > 60) {
							title2 = title2.substr(0, 60) + '...';
						}
						id = DLNA_extractXmlAttribute(items[i], 'id');
						if (id == undefined) {
							id = '';
						}
						id = 'item:' + id;
						html += '<option ';
						if (id == DLNA_selectedMedia) {
							html += 'selected ';
						}
						html += 'value="' + id + '">' + title2 + '</option>';
					}
				}
				$('media').innerHTML = html;
				if (DLNA_browserIE) {
					$('media').outerHTML=$('media').outerHTML.replace($('media').innerHTML+'</select>',html+'</select>');
				}
				DLNA_loading = false;
			}
			DLNA_prevResultBrowse = resultBrowse;
			DLNA_prevOnlineState = onlineState;
			DLNA_selectMedia();
		}

		if (DLNA_loading == false) {
			$('status').innerHTML = resultPlayback;
			if (resultPlayback == 'Media OK' || resultPlayback == 'Done') {
				$('status').style.color = "green";
			}
			else {
				$('status').style.color = "red";
			}
		}

		DLNA_prevControls = controls;
		DLNA_prevOnlineState = onlineState;
		DLNA_prevCurrentAlbumArtUrl = currentAlbumArtUrl;
		DLNA_prevTitle = title;
		DLNA_prevAlbum = album;
		DLNA_prevArtist = artist;
		DLNA_prevDuration = duration;
		DLNA_prevPlaying = playing;
		DLNA_prevActions = actions;
		DLNA_prevMute = mute;
		DLNA_prevVolume = volume;
		DLNA_prevResultDiscovery = resultDiscovery;
		DLNA_prevResultBrowse = resultBrowse;
		DLNA_prevSinkProtocols = sinkProtocols;
		DLNA_prevResultPlayback = resultPlayback;
	}

	DLNA_timeoutVar = setTimeout("DLNA_refreshPlayer("+device+")", 1000);
}

function DLNA_refreshDiscovery(device)
{
	var modelName = get_device_state(device, DLNA_DMC_SID, "ModelName", 1);
	if (modelName == undefined) {
		modelName = '';
	}
	var url = get_device_state(device, DLNA_DMC_SID, "DescriptionURL", 1);
	if (url == undefined) {
		url = '';
	}
	var onlineState = get_device_state(device, DLNA_DMC_SID, "Online", 1);
	if (onlineState == '1') {
		onlineState = 'ON';
	}
	else {
		onlineState = 'OFF';
	}
	var proxy = get_device_state(device, DLNA_DMC_SID, "ProxyUsed", 1);
	if (proxy == undefined) {
		proxy = '';
	}
	var resultDiscovery = get_device_state(device, DLNA_DMC_SID, "DMRDiscoveryResult", 1);
	if (resultDiscovery == undefined) {
		resultDiscovery = '';
	}
	if (modelName != DLNA_prevModelName
		|| url != DLNA_prevUrl
		|| onlineState != DLNA_prevOnlineState2
		|| proxy != DLNA_prevProxy
		|| resultDiscovery != DLNA_prevResultDiscovery2) {

		DLNA_prevModelName = modelName;
		DLNA_prevUrl = url;
		DLNA_prevOnlineState2 = onlineState;
		DLNA_prevProxy = proxy;
		DLNA_prevResultDiscovery2 = resultDiscovery;

		$('model').innerHTML = modelName;
		$('url').innerHTML = url;
		$('state').innerHTML = onlineState;
		$('proxy').innerHTML = proxy;

		if (resultDiscovery == 'scanning') {
			$('DMRdiscover').disabled = true;
			$('DMRdiscover').innerHTML = 'Scanning ...';
			$('DMRdiscovery').innerHTML = '';
			$('selectDMRDiscovery').disabled = true;
		}
		else if (resultDiscovery == "") {
			$('DMRdiscover').disabled = false;
			$('DMRdiscover').innerHTML = 'Discover';
			$('selectDMRDiscovery').disabled = true;
			$('DMRdiscovery').innerHTML = '';
		}
		else {
			$('DMRdiscover').disabled = false;
			$('DMRdiscover').innerHTML = 'Discover';
			$('selectDMRDiscovery').disabled = false;

			var html = '';
			var xml = DLNA_parseXml(resultDiscovery);
			if (typeof xml != 'undefined') {
				var items = xml.getElementsByTagName("device");
				for (i=0; i<items.length; i++) {
					var descrUrl = DLNA_extractXmlTag(items[i], 'descriptionURL');
					if (descrUrl == undefined) {
						descrUrl = '';
					}
					var selected = '';
					if (descrUrl == url) {
						selected = ' selected';
					}
					var name = DLNA_extractXmlTag(items[i], 'friendlyName');
					if (name == undefined) {
						name = '';
					}
					html += '<option ' + selected + ' value="' + descrUrl + '">' + name + '</option>';
				}
			}
			$('DMRdiscovery').innerHTML = html;
			if (DLNA_browserIE) {
				$('DMRdiscovery').outerHTML=$('DMRdiscovery').outerHTML.replace($('DMRdiscovery').innerHTML+'</select>',html+'</select>');
			}
		}
	}

	DLNA_timeoutVar2 = setTimeout("DLNA_refreshDiscovery("+device+")", 1000);
}

function DLNA_play(device)
{
	DLNA_callAction(device, MEDIA_NAVIGATION_SID, 'Play', {} );
}

function DLNA_pause(device)
{
	DLNA_callAction(device, MEDIA_NAVIGATION_SID, 'Pause', {} );
}

function DLNA_stop(device)
{
	DLNA_callAction(device, MEDIA_NAVIGATION_SID, 'Stop', {} );
}

function DLNA_prevTrack(device)
{
	DLNA_callAction(device, MEDIA_NAVIGATION_SID, 'SkipUp', {} );
}

function DLNA_nextTrack(device)
{
	DLNA_callAction(device, MEDIA_NAVIGATION_SID, 'SkipDown', {} );
}

function DLNA_mute(device)
{
	DLNA_callAction(device, RENDERING_CONTROL_SID, 'SetMute', {} );
}

function DLNA_playUri(device)
{
	var uri = encodeURIComponent($('uri').value);
	var protocol = '';
	if ($('sinkProtocols').selectedIndex >= 0) {
		protocol = $('sinkProtocols').options[$('sinkProtocols').selectedIndex].value;
	}
	var duration = $('duration1').value;
	var volume = $('volume1').value;
	//$('debug').innerHTML = uri + ' ' + protocol + ' ' + duration + ' ' + volume;
	if (uri != "") {
		DLNA_callAction(device, DLNA_DMC_SID, 'Play', {'URI':uri, 'Protocol':protocol, 'Duration':duration, 'Volume':volume} );
	}
}

function DLNA_selectLang()
{
	if ($('language1').selectedIndex >= 0) {
		$('language').value = $('language1').options[$('language1').selectedIndex].value;
	}
}

function DLNA_say(device)
{
	var text = $('text').value;
	var lang = $('language').value;
	var volume = $('volume').value;
	//$('debug').innerHTML = text + ' ' + lang + ' ' + vol;
	if (text != "") {
		DLNA_callAction(device, DLNA_DMC_SID, 'Say', {'Text':text, 'Language':lang, 'Volume':volume} );
	}
}

function DLNA_startDMRDiscovery(device)
{
	DLNA_callAction(device, DLNA_DMC_SID, 'StartDMRDiscovery', {} );
}

function DLNA_selectDMRDiscovery(device)
{
	if ($('DMRdiscovery').selectedIndex >= 0) {
		var url = $('DMRdiscovery').options[$('DMRdiscovery').selectedIndex].value;
		//$('debug').innerHTML = url;
		DLNA_callAction(device, DLNA_DMC_SID, 'SelectDMRDevice', {'URL':url} );
	}
}

function DLNA_selectURL(device)
{
	var url = $('newURL').value;
	if (url != "") {
		//$('debug').innerHTML = url;
		DLNA_callAction(device, DLNA_DMC_SID, 'SelectDMRDevice', {'URL':url} );
	}
}

function DLNA_checkState(device)
{
	var url = $('url').innerHTML;
	if (url != "") {
		//$('debug').innerHTML = url;
		DLNA_callAction(device, DLNA_DMC_SID, 'SelectDMRDevice', {'URL':url} );
	}
}

function DLNA_disableDMSCmds()
{
	DLNA_loading = true;
	$('media').innerHTML = '';
	$('protocols').innerHTML = '';
	$('status').innerHTML = 'Loading...';
	$('status').style.color = "red";
	$('discover').disabled = true;
	$('browse').disabled = true;
	$('back').disabled = true;
	$('top').disabled = true;
}

function DLNA_startDMSDiscovery(device)
{
	DLNA_selectedMedia = undefined;
	DLNA_mediaObjects = new Array();
	DLNA_disableDMSCmds();
	DLNA_callAction(device, DLNA_DMC_SID, 'StartDMSDiscovery', {} );
}

function DLNA_browseMedia(device)
{
	var value;
	var url;
	var id;
	var protocol;
	if ($('media').selectedIndex >= 0) {
		value = $('media').options[$('media').selectedIndex].value;
		if (value.indexOf('server:') == 0) {
			url = value.substr(7);
			id = '0';
			DLNA_mediaObjects.push(id);
			DLNA_disableDMSCmds();
			DLNA_lastSelectedDMS = url;
			DLNA_lastPlayedMediaObject = '';
			DLNA_lastUsedProtocol = '';
			url = encodeURIComponent(url);
			DLNA_callAction(device, DLNA_DMC_SID, 'BrowseDMS', {'DescriptionURL':url, 'ObjectID':id} );
		}
		else if (value.indexOf('container:') == 0) {
			id = value.substr(10);
			DLNA_mediaObjects.push(id);
			DLNA_disableDMSCmds();
			id = encodeURIComponent(id);
			DLNA_callAction(device, DLNA_DMC_SID, 'BrowseDMS', {'ObjectID':id} );
		}
		else if (value.indexOf('item:') == 0 && $('protocols').selectedIndex >= 0) {
			id = value.substr(5);
			protocol = $('protocols').options[$('protocols').selectedIndex].value;
			DLNA_lastPlayedMediaObject = id;
			DLNA_lastUsedProtocol = protocol;
			id = encodeURIComponent(id);
			DLNA_callAction(device, DLNA_DMC_SID, 'PlayDMSMedia', {'ObjectID':id, 'Protocol':protocol} );
		}
	}
}

function DLNA_browseTop(device)
{
	if (DLNA_mediaObjects.length > 0) {
		DLNA_selectedMedia = undefined;
		DLNA_mediaObjects = new Array();
		DLNA_prevResultBrowse = undefined;
		DLNA_disableDMSCmds();
	}
}

function DLNA_browseBack(device)
{
	var id;
	if (DLNA_mediaObjects.length > 0) {
		DLNA_selectedMedia = undefined;
		DLNA_mediaObjects.pop();
		if (DLNA_mediaObjects.length == 0) {
			DLNA_prevResultBrowse = undefined;
			DLNA_disableDMSCmds();
		}
		else {
			id = encodeURIComponent(DLNA_mediaObjects[DLNA_mediaObjects.length-1]);
			DLNA_disableDMSCmds();
			DLNA_callAction(device, DLNA_DMC_SID, 'BrowseDMS', {'ObjectID':id} );
		}
	}
}

function DLNA_selectMedia()
{
    var html = '';
	var buttonLabel = 'Browse';
	var buttonDisabled = false;
	var value;
	if ($('media').selectedIndex >= 0) {
		DLNA_selectedMedia = $('media').options[$('media').selectedIndex].value;
		if (DLNA_selectedMedia.indexOf('item:') == 0) {
			buttonLabel = 'Play';
			if (DLNA_prevOnlineState == '1') {
				buttonDisabled = false;
			}
			else {
				buttonDisabled = true;
			}
			value = DLNA_selectedMedia.substr(5);
			//$('debug').innerHTML = value;
			html = '<option selected value="AUTO">Automatic</option>';
			html += '<option value="">None</option>';
			var xml = DLNA_parseXml(DLNA_prevResultBrowse);
			if (typeof xml != 'undefined') {
				var id;
				var protocol;
				var protocol2;
				var items = xml.getElementsByTagName("item");
				for (i=0; i<items.length; i++) {
					id = DLNA_extractXmlAttribute(items[i], 'id');
					if (id == value) {
						for (j=0; j<items[i].childNodes.length; j++) {
							if (items[i].childNodes[j].tagName == 'res') {
								protocol = items[i].childNodes[j].getAttribute('protocolInfo');
								if (protocol != undefined) {
									if (protocol.length > 60) {
										protocol2 = protocol.substr(0, 60) + '...';
									}
									else {
										protocol2 = protocol;
									}
									html += '<option value="' + protocol + '">' + protocol2 + '</option>';
								}
							}
						}
						break;
					}
				}
			}
		}
	}
	$('protocols').innerHTML = html;
	if (DLNA_browserIE) {
		$('protocols').outerHTML=$('protocols').outerHTML.replace($('protocols').innerHTML+'</select>',html+'</select>');
	}
	$('browse').innerHTML = buttonLabel;
	if (DLNA_loading == false) {
		$('browse').disabled = buttonDisabled;
	}
}

function DLNA_callAction(device, sid, actname, args) {
	var q={
		'id':'lu_action',
		'output_format':'xml',
		'DeviceNum':device,
		'serviceId':sid,
		'action':actname
	};
	var key, count = 0;
	for(key in args) {
		count++;
	}
	if (count > 0) {
		Object.extend(q, args);
	}
    if (DLNA_browserIE) {
    	Object.extend(q, {timestamp: new Date().getTime()}); //we need this to avoid IE caching of the AJAX get
    }
	new Ajax.Request (command_url+'/data_request', {
		method: 'get',
		parameters: q,
		onSuccess: function (response) {
		},
		onFailure: function (response) {
		},
		onComplete: function (response) {
		}
	});
}

